import numpy as np


class BIRD:
    def __init__(self, sim, delta, prior, t1, t2):
        # initialize here
        self.sim = sim
        self.delta_sim = delta
        self.prior = prior
        self.t1 = t1
        self.t2 = t2
        self.initialize()

    def reset(self, prior=None, sim=None, delta=None):
        # reset here
        if prior is not None:
            self.prior = prior
        if sim is not None:
            self.sim = sim
        if delta is not None:
            self.delta_sim = delta
        self.initialize()

    def initialize(self):
        # initial calculation here
        sim = self.sim
        delta_sim = self.delta_sim
        prior = self.prior
        self.n = sim.shape[0]
        self.n_delta = delta_sim.shape[0]
        self.k = self.n * prior
        self.class_num = prior.shape[0]
        self.s_prime = -1000000 * np.ones((self.class_num, 1))
        self.NN = np.zeros((self.n, self.class_num))
        self.select_num = 0
        self.tmp_labeled = np.zeros((self.n, 1))
        self.C_discovered = np.zeros((self.class_num, 1))
        self.C_discovered[0] = 1
        self.no_label = np.zeros((self.n, 1))
        self.index = 0
        n_delta = self.n_delta
        k = self.k
        n = self.n
        print 'cal sim start'
        for m in delta_sim:
            print m
            # u = np.zeros((n, 1))
            # v = np.zeros((1, n))
            # u[int(delta_sim[m, 0])] = 1
            # v[0, int(delta_sim[m, 1])] = delta_sim[m, 2]
            u = m.copy()
            u[u!=0] = 1
            u = np.transpose(u)
            v = m
            sim = sim + 0.001 * sim.dot(u).dot(v.dot(sim)) / (1 + v.dot(sim).dot(u))
        sim = np.array(sim)
        np.save('sim.npy', sim)
        print 'cal knn start'
        KNN_sim = np.zeros((n, n))
        KNN = np.zeros((n, n))
        for i in xrange(n):
            print i
            Y = np.sort(sim[i, :])[::-1]
            I = np.argsort(sim[i, :])[::-1]
            KNN_sim[i, :] = Y
            KNN[i, :] = I
            for j in xrange(1, self.class_num):
                if self.s_prime[j] < Y[int(k[j]) - 1]:
                    self.s_prime[j] = Y[int(k[j]) - 1]
        self.KNN_sim = KNN_sim
        self.KNN = KNN
        self.s_prime[0] = np.amin(self.s_prime[1:])
        print self.s_prime
        for i in xrange(n):
            for j in xrange(n):
                mark = 0
                for s in range(self.class_num):
                    if KNN_sim[i, j] >= self.s_prime[s]:
                        self.NN[i, s] += 1
                        mark = 1
                if mark == 0:
                    break
        print 'cal NN finish'
        self.t = 1
        np.save("knn.npy", self.KNN)
        np.save("knn_sim.npy", self.KNN_sim)
        np.save("nn.npy", self.NN)
        np.save("s_prime.npy", self.s_prime)
        # self.KNN = np.load("knn.npy")
        # self.KNN_sim = np.load("knn_sim.npy")
        # self.NN = np.load("nn.npy")
        # self.s_prime = np.load("s_prime.npy")

    def next_iter(self, batch_number):
        class_num = self.class_num
        for index in range(0, class_num):
            index = self.index
            try:
                while self.C_discovered[index] == 1 and index < self.class_num:
                    index += 1
            except IndexError, e:
                print index
        if index == self.class_num:
            return
        self.index = index
        s = self.s_prime[index]
        n = self.sim.shape[0]
        res = []
        t = self.t
        score_seq = np.zeros((batch_number, n, 1))
        # score_seq = np.load("scores.npy")
        self.score_list = []
        for batch in xrange(0, batch_number):
            score = np.zeros((n, 1))
            for i in xrange(n):
                if self.no_label[i] == 1:
                    score[i, 0] = -1000000
                    continue
                for j in xrange(1, n):
                    if index == 1 and i == 224 and j == 3:
                        print 'here'
                    try:
                        if self.KNN_sim[i, j] >= s / (t + 1):
                            tmp = self.NN[i, index] - self.NN[int(self.KNN[i, j]), index]
                            if tmp > score[i, 0]:
                                score[i, 0] = tmp
                        else:
                            if j == 1:
                                score[i, 0] = self.NN[i, index]
                            else:
                                break
                    except RuntimeWarning:
                        print self.KNN_sim[i, j], s, t+1
            score_seq[batch] = score
            # score = score_seq[batch]
            self.score_list.append(score)
            Y = np.sort(score[:, 0])[::-1]
            I = np.argsort(score[:, 0])[::-1]
            self.select_num += 1
            self.tmp_labeled[self.select_num - 1] = I[0]
            self.no_label[int(I[0])] = 1
            res.append({'index': I[0], 'score': Y[0], 'all_score': np.transpose(score)[0].tolist()})
            if len(res) == batch_number:
                break
        np.save("scores.npy", score_seq)
        self.t += 1
        print res
        # res = [3639, 1819, 0, 1820, 1821, 1, 4, 1822, 5, 6, 1824, 1823, 2, 7, 8, 1826, 9, 1827, 3, 10]
        return res

    def label(self, label_res):
        res = True
        for node in label_res.keys():
            node_class = int(label_res[node]) - 1
            if self.C_discovered[node_class] == 0:
                self.C_discovered[node_class] = 1
                flag = 1
                if node_class == self.index:
                    self.t = 1
                for i in range(self.class_num):
                    flag *= self.C_discovered[i][0]
                if flag == 1:
                    res = False
        return res

    def get_knn(self, node):
        return self.KNN[node][0:self.k[self.index]], self.k[self.index]

    def get_knns(self, nodes):
        print self.k[self.index]
        res = []
        for n in nodes:
            print self.KNN[n]
            res.append(self.KNN[n][0:self.k[self.index]])
        return res

    def get_scores(self, c_index):
        score_res = np.transpose(self.score_list[int(c_index)])[0].tolist()
        print "############################################"
        print "score list is :", len(score_res)
        print "############################################"
        return score_res
